module Pddapi
  class Pinduoduo
    include Pddapi

    def post_data(uri, params)
      req = Net::HTTP::Post.new(uri)
      req.set_form_data(params)
      res = Net::HTTP.start(uri.hostname, uri.port) do |http|
        http.request(req)
      end
      case res
      when Net::HTTPSuccess
        return res.body 
      else
        return  "{\"status\": 0}"
      end

    end

    def pdd_ddk_goods_search(keyword, client_id, secret, sort_type = 0, with_coupon = true, page = 1, page_size = 20)
      action_params = {
        keyword: keyword,
        sort_type: sort_type,
        with_coupon: with_coupon,
        page: page,
        page_size: page_size
      }
      params = system_params('pdd.ddk.goods.search', client_id).merge(action_params)
      my_sign = get_sign(params, secret).upcase
      post_data(URI(PDDURI), params.merge({sign: my_sign}))
    end
    
    def pdd_ddk_goods_detail(goods_id, client_id, secret)
      action_params = {
        goods_id_list: "[#{goods_id}]"
      }
      params = system_params('pdd.ddk.goods.detail', client_id).merge(action_params)
      my_sign = get_sign(params, secret).upcase
      post_data(URI(PDDURI), params.merge({sign: my_sign}))
    end

    def pdd_ddk_goods_promotion_url_generate(pid, goods_id, multi_group, client_id, secret)
      action_params = {
        p_id: pid,
        goods_id_list: "[#{goods_id}]",
        generate_short_url: true,
        multi_group: multi_group
      }
      params = system_params('pdd.ddk.goods.promotion.url.generate', client_id).merge(action_params)
      my_sign = get_sign(params, secret).upcase
      post_data(URI(PDDURI), params.merge({sign: my_sign}))
    end

    def pdd_ddk_act_prom_url_generate(pid, client_id, secret)
      action_params = {
        url_type: 1,
        generate_short_url: true,
        generate_mobile_short_url: true,
        p_id_list: [pid].to_json
      }
      params = system_params('pdd.ddk.act.prom.url.generate', client_id).merge(action_params)
      my_sign = get_sign(params, secret).upcase
      post_data(URI(PDDURI), params.merge({sign: my_sign}))
    end

    def pdd_ddk_rp_prom_url_generate(pid, client_id, secret)
      action_params = {
        generate_short_url: true,
        p_id_list: [pid].to_json
      }
      params = system_params('pdd.ddk.rp.prom.url.generate', client_id).merge(action_params)
      my_sign = get_sign(params, secret).upcase
      post_data(URI(PDDURI), params.merge({sign: my_sign}))
    end

    def pdd_ddk_cms_prom_url_generate(pid, multi_group, client_id, secret)
      action_params = {
        p_id_list: [pid].to_json,
        generate_short_url: true,
        generate_mobile: true,
        multi_group: multi_group
      }
      params = system_params('pdd.ddk.cms.prom.url.generate', client_id).merge(action_params)
      my_sign = get_sign(params, secret).upcase
      post_data(URI(PDDURI), params.merge({sign: my_sign}))
    end

    def pdd_ddk_theme_list_get(client_id, secret, page = 1,page_size = 20)
      action_params = {
        page: page,
        page_size: page_size 
      }
      params = system_params('pdd.ddk.theme.list.get', client_id).merge(action_params)
      my_sign = get_sign(params, secret).upcase
      post_data(URI(PDDURI), params.merge({sign: my_sign}))
    end

    def pdd_ddk_theme_goods_search(theme_id, client_id, secret)
      action_params = {
        theme_id: theme_id
      }
      params = system_params('pdd.ddk.theme.goods.search', client_id).merge(action_params)
      my_sign = get_sign(params, secret).upcase
      post_data(URI(PDDURI), params.merge({sign: my_sign}))
    end

    def pdd_ddk_theme_prom_url_generate(theme_id_list, pid, client_id, secret)
      action_params = {
        pid: pid,
        theme_id_list: theme_id_list,
        generate_short_url: true,
        generate_mobile: true
      }
      params = system_params('pdd.ddk.theme.prom.url.generate', client_id).merge(action_params)
      my_sign = get_sign(params, secret).upcase
      post_data(URI(PDDURI), params.merge({sign: my_sign}))
    end

  end
end
